﻿using System;
using System.Data;
using System.Data.OleDb;

namespace EmployeesReader {
    class Program {
        // Establish connection
        static void Main(string[] args) {
            string connStr = "provider=SQLOLEDB;data source=IrfanLaptop;"
                + "initial catalog=Northwind;user id=sa;password=123;"
                + "Trusted_Connection=true;";
            IDbConnection con = null; // Declare connection object
            try {
                // 1. Create connection object
                con = new OleDbConnection(connStr);
                con.Open(); // Open connection
                // 2. Execute command
                // --- Create SQL command
                IDbCommand cmd = con.CreateCommand();
                cmd.CommandText = "SELECT EmployeeID, LastName, " +
                    "FirstName FROM Employees";
                // --- Execute SQL Command; result is an OleDbDataReader
                IDataReader reader = cmd.ExecuteReader();
                object[] dataRow = new object[reader.FieldCount];
                // 3. Process result
                while (reader.Read()) {
                    int cols = reader.GetValues(dataRow);
                    for (int i = 0; i < cols; i++) {
                        Console.Write("| {0} ", dataRow[i]);
                    }
                    Console.WriteLine();
                }
                // 4. Release resources
                // --- Close reader
                reader.Close();
            } catch (Exception e) {
                Console.WriteLine(e.Message);
            } finally {
                try {
                    if (con != null) {
                        // 5. Close connection
                        // --- Close con: the connection object
                        con.Close();
                    }
                } catch (Exception ex) {
                    Console.WriteLine(ex.Message);
                }
            }
        }
    }
}
