﻿using System;
using System.Data;

public partial class MyADO2 : System.Web.UI.Page {
    protected void Button1_Click(object sender, EventArgs e) {
        // Create DataSet ds & DataTable "Person"
        DataSet ds = new DataSet("PersonContacts");
        DataTable personTable = new DataTable("Person");
        // Define the column "ID" and its properties
        DataColumn col = new DataColumn();
        col.DataType = typeof(System.Int64);
        col.ColumnName = "ID";
        col.ReadOnly = true;
        col.Unique = true;
        col.AutoIncrement = true;
        col.AutoIncrementSeed = 1;
        col.AutoIncrementStep = 1;
        // Add the column to the table and set the PK (Primary Key)
        personTable.Columns.Add(col);
        personTable.PrimaryKey = new DataColumn[] { col };
        // Define the other column and add it to the table
        col = new DataColumn();
        col.DataType = typeof(string);
        col.ColumnName = "FirstName";
        personTable.Columns.Add(col);
        // Define the other column and add it to the table
        col = new DataColumn();
        col.DataType = typeof(string);
        col.ColumnName = "LastName";
        personTable.Columns.Add(col);
        // Add the table to the DataSet
        ds.Tables.Add(personTable);

        // Create DataTable "Contact"
        DataTable contactTable = new DataTable("Contact");
        // Define the column "ID" and its properties
        col = new DataColumn();
        col.DataType = typeof(System.Int64);
        col.ColumnName = "ID";
        col.ReadOnly = true;
        col.Unique = true;
        col.AutoIncrement = true;
        col.AutoIncrementSeed = -1;
        col.AutoIncrementStep = -1;
        // Add the column to the table and set the PK (Primary Key)
        contactTable.Columns.Add(col);
        contactTable.PrimaryKey = new DataColumn[] { col };
        // Define the other column and add it to the table
        col = new DataColumn();
        col.DataType = typeof(string);
        col.ColumnName = "FirstName";
        contactTable.Columns.Add(col);
        // Define the other column and add it to the table
        col = new DataColumn();
        col.DataType = typeof(string);
        col.ColumnName = "LastName";
        contactTable.Columns.Add(col);
        // Define the other column and add it to the table
        col = new DataColumn();
        col.DataType = typeof(string);
        col.ColumnName = "NickName";
        contactTable.Columns.Add(col);
        // Define the other column and add it to the table
        col = new DataColumn();
        col.DataType = typeof(string);
        col.ColumnName = "Email";
        contactTable.Columns.Add(col);
        // Define the other column and add it to the table
        col = new DataColumn();
        col.DataType = typeof(string);
        col.ColumnName = "Phone";
        contactTable.Columns.Add(col);
        // Define the column "PersonID" and add it to the table
        col = new DataColumn();
        col.DataType = typeof(System.Int64);
        col.ColumnName = "PersonID";
        contactTable.Columns.Add(col);

        // Add the table to the DataSet
        ds.Tables.Add(contactTable);

        // Define the relationship
        DataColumn parentCol = ds.Tables["Person"].Columns["ID"];
        DataColumn childCol = ds.Tables["Contact"].Columns["PersonID"];
        DataRelation rel = new DataRelation("PersonHasContacts",
            parentCol, childCol);
        ds.Relations.Add(rel);

        // 1
        // Data operation: add a data to the table "Person"
        // Define a new row & its values
        DataRow personRow = personTable.NewRow();
        personRow[1] = "Wolfgang";
        personRow["LastName"] = "Beer";
        // Add the row to the table
        personTable.Rows.Add(personRow);
        // Data operation: add a data to the table "Contact"
        // Define a new row & its values
        DataRow contactRow = contactTable.NewRow();
        contactRow["FirstName"] = "Wolfgang";
        contactRow["LastName"] = "Beer";
        contactRow["Phone"] = "08123456789";
        contactRow["PersonID"] = (long)personRow["ID"]; // Defines a relation
        // Add the row to the table
        contactTable.Rows.Add(contactRow);
        // 2
        // Add a data to the table "Person"
        // Define a new row & its values
        personRow = personTable.NewRow();
        personRow[1] = "Maria";
        personRow["LastName"] = "Sharapova";
        // Add the row to the table
        personTable.Rows.Add(personRow);
        // Add a data to the table "Contact"
        // Define a new row & its values
        contactRow = contactTable.NewRow();
        contactRow["FirstName"] = "Maria";
        contactRow["LastName"] = "Sharapova";
        contactRow["Phone"] = "08555555555";
        contactRow["PersonID"] = (long)personRow["ID"];
        contactTable.Rows.Add(contactRow);
        // 3
        // Add a data to the table "Person"
        // Define a new row & its values
        personRow = personTable.NewRow();
        personRow["FirstName"] = "Anna";
        personRow["LastName"] = "Kournikova";
        // Add the row to the table
        personTable.Rows.Add(personRow);
        // Add a data to the table "Contact"
        // Define a new row & its values
        contactRow = contactTable.NewRow();
        contactRow["FirstName"] = "Anna";
        contactRow["LastName"] = "Kournikova";
        contactRow["Phone"] = "08333333333";
        contactRow["PersonID"] = (long)personRow["ID"];
        contactTable.Rows.Add(contactRow);

        // Accept the changes permanently, if there's no errors
        if (ds.HasErrors) {
            ds.RejectChanges();
        } else {
            ds.AcceptChanges();
        }

        // DataView
        DataView dataView = new DataView(personTable);
        //dataView.RowFilter = "FirstName < 'N'";
        //dataView.RowStateFilter = DataViewRowState.Added | DataViewRowState.ModifiedCurrent;
        dataView.Sort = "LastName ASC";

        // GridView
        GridView1.DataSource = dataView;
        GridView1.DataBind();
        GridView1.HeaderStyle.BackColor = System.Drawing.Color.LightBlue;
        GridView1.AlternatingRowStyle.BackColor = System.Drawing.Color.LightYellow;

        //int i = dataView.Find("Sharapova");
        int i = dataView.Find("Kournikova");
        //int i = dataView.Find("Beer");
        if (i >= 0) {
            GridView1.Rows[i].BackColor = System.Drawing.Color.Yellow;
        }

    }
}
